//#include "structures.h"
#include "stdlib.h"
//#include "niveaux.h"
#ifndef ZOMBIES_H
#define ZOMBIES_H
typedef enum{
	GAUCHE, DROITE, HAUT, BAS
}dir;
typedef enum{
	LABO, FORET, GROTTE
}environnement;
typedef enum{
	PISTOLET, POMPE, BAZOOKA, MIT/*raillette*/, COUTEAU, SNIPER, RIEN
}typeWeapon;
typedef enum{
	DEBUT, MORT,FIN, NB_ZOMBIES_RESTANTS, ZOMBIE_VU /*Ne sert qu'une fois*/, X, Y, XY, TROU_VU, ARME_OBTENUE
}event;
typedef struct missile missile;
struct missile
{
	missile* suivant;
	int x;
	int y;
	int n;
	int est; /*hooo ça vole haut !*/
	int explose;
	dir direction;
};
typedef struct movPlat movPlat;
struct movPlat
{
	movPlat* suivant;
	int x;
	int y;
	dir direction;
};
typedef struct message message;
struct message{
	int duree;
	int vu;
	char* texte;
	event e;
	int parametres[5];
	typeWeapon param;
	int disp;

};
typedef struct cube cube;
struct cube{
	int x;
	int y;
};
typedef struct bras bras;
struct bras{
	int x;
	int y;
	int lifetime;
};
typedef struct tete tete;
struct tete{
	int x;
	int y;
	int lifetime;
};
/*
typedef struct grenade grenade;
struct grenade{
	int x;
	int y;
	int delai;
	int nEx;
	dir direction;
};*/

typedef struct{
	char* map;
	int hauteur;
	int longueur;
	int nbMessages;
	message* messages;
	int id;
	movPlat* m;
}niveau;
typedef struct{
	int x;
	int y;
	int dx;
	int dy;
}cam;

typedef struct weapon weapon;
struct weapon{
	int delai;
	typeWeapon type;
	int degats;
};

typedef struct zombie zombie;
struct zombie{
	int x;
	int y;
	dir direction;
	int vie;
	int touche;
	int bras;
	int aTete;
	int nZ;
	zombie* suivant;
	bras b;
	tete t;
};

typedef struct joueur joueur;
struct joueur{
	int x;
	int y;
	int dx;
	int dy;
	int compteurSaut;
	int peutSauter;
	int delai;
	dir direction;
	int vie;
	weapon armeSel;
	typeWeapon armeDispo[6];
	int mort;
	int delaiMort;
	int freeze;
	missile* mis;
	int nbArmes;
	int canPass;
	int sniperLoad;
};
zombie* clear(zombie* liste);
zombie* ajouterZombie( zombie* liste, int x, int y);
zombie* supprimerZombie( zombie* liste);
zombie* gestionTirs(zombie* liste, int yTir, joueur* joueur, cam* camera, niveau* niveau);
zombie* iaZombie(zombie* liste, niveau* niveau);
void affZombie(zombie* liste, cam* camera, int score);
zombie* supprimer(zombie* liste, int valeur);
//zombie* degatsGre(zombie* liste, grenade* g1);
void invertSpritesZombies();
void movTete(zombie* liste, niveau* niv);
void pivoter(const unsigned char* source, unsigned char* destination);
int collision(joueur* jo, zombie* liste);
int cercle(int x,int y,int x2, int y2, int r);
zombie* couteauTest( zombie* liste, joueur* joueur, cam* camera);
int testMissile(missile* mis, niveau* niv, zombie* liste);
zombie* destruction(int x, int y, int r, zombie* liste, niveau* niv, cam camera);
#endif